// test the lexer on a variety of tokens


import java.io.*;
import jbf.*;
import YYlex;
import YYtokentypes;

public class Main {

public static YYlex yyl = new YYlex(System.in,System.out);
public static YYparse yyp = new YYparse(yyl);

public static void main(String argv[])
{
    boolean debuglex = false;
    boolean debugparse = false;
    boolean lexonly = false;
    YYtoken yylval;
    int llevel = 0;
    int plevel = 0;

    for(int i=0;i<argv.length;i++) {
	if(argv[i].compareTo("-debug")==0) {debuglex = debugparse = true;}
	else if(argv[i].compareTo("-debuglex")==0) {debuglex = true;}
	else if(argv[i].compareTo("-debugparse")==0) {debugparse = true;}
	else if(argv[i].compareTo("-lex")==0) {lexonly = true;}
	else if(argv[i].compareTo("-l")==0) {
	    if(i == argv.length) {
		System.err.println("-l requires an argument");
	 	return;
	    }
	    i++;
	    try {
		llevel = (Integer.valueOf(argv[i])).intValue();
	    } catch (Exception e) {
		System.err.println("-l requires an integer argument");
	 	return;
	    }
	} else if(argv[i].compareTo("-p")==0) {
	    if(i == argv.length) {
		System.err.println("-p requires an argument");
	 	return;
	    }
	    i++;
	    try {
		plevel = (Integer.valueOf(argv[i])).intValue();
	    } catch (Exception e) {
		System.err.println("-p requires an integer argument");
	 	return;
	    }
	}
    }
    yyl = new YYlex(System.in,System.out);
    yylval = yyl.yylval;
    if(!lexonly) yyp = new YYparse(yyl); else yyp = null;
    if(debuglex) {
	System.out.println("lex debug turned on");
	if(llevel > 0) yyl.setdebug(llevel); else yyl.setdebug(true);
    }
    if(yyp != null && debugparse) {
	System.out.println("parse debug turned on");
	if(plevel > 0) yyp.setdebug(plevel); else yyp.setdebug(true);
    }
    try {        
	if(lexonly) {
	    do {
		yyl.yylex();
	    } while (yylval != null);
	    System.out.println("lex succeeded");
	} else {
	    yyp.yyparse();
	    System.out.println("parse succeeded");
	}
    } catch (Exception e) {
        System.out.println("exception detected:" + e.getMessage());
        e.printStackTrace();
        System.out.println("parse failed");
    }
}

}; /*class Main*/
