// test the lexer on a variety of tokens


import java.io.*;
import jbf.*;
import YYlex;
import YYtokentypes;

public class Main {

public static YYlex yyl = new YYlex(System.in,System.out);

public static void main(String argv[])
{
    boolean debuglex = false;
    boolean debugparse = false;
    YYtoken yylval;

    if(argv.length > 0) {
	if(argv[0].compareTo("-debug")==0) {debuglex = debugparse = true;}
	else if(argv[0].compareTo("-debuglex")==0) {debuglex = true;}
	else if(argv[0].compareTo("-debugparse")==0) {debugparse = true;}
    }
    if(debuglex) {
	System.out.println("lex debug turned on");
	yyl.setdebug(1);
    }
    try {        
	do {
	    yylval = yyl.yylex();
	} while (yylval != null);
	System.out.println("lex succeeded");
    } catch (Exception e) {
        System.out.println("exception detected:" + e.getMessage());
        e.printStackTrace();
        System.out.println("parse failed");
    }
}

}; /*class Main*/
